## martian-modem 20080617

=== Makefile ===
all: 
	$(MAKE) -C kmodule/ modules
	$(MAKE) -C modem/ all
#	$(MAKE) -C utils/ ptytosock

install:
	$(MAKE) -C kmodule/ install
	$(MAKE) -C modem/ install

clean:
	$(MAKE) -C kmodule/ clean
	$(MAKE) -C modem/ clean

=== kmodule/Makefile ===
KRELEASE = $(shell uname -r)
KBUILD_DIR = /lib/modules/$(KRELEASE)/build
MSRC_DIR = $(shell pwd)

martian_cppflags = -DKMARTIAN_STAMP=20080617
EXTRA_CFLAGS	+= $(martian_cppflags)
ccflags-y	+= $(martian_cppflags)

# kbuild
martian_dev-objs = martian.o marsio.o mfifo.o
obj-m = martian_dev.o

all: modules

modules:
	$(MAKE) -C $(KBUILD_DIR) M="$(MSRC_DIR)"  modules

clean:
	$(MAKE) -C $(KBUILD_DIR) M="$(MSRC_DIR)" clean

install:
	$(MAKE) -C $(KBUILD_DIR) M="$(MSRC_DIR)" modules_install
	if ! /sbin/modprobe -nq martian_dev ; then /sbin/depmod -a; fi
#

# dependencies 
martian.o: martian_ids.c marsio.h ../martian.h
martian_dev-objs: kmartian.h mfifo.h

=== modem/Makefile ===


SHELL	    := /bin/bash

CC	    := gcc

CFLAGS	    := -Wall
#CPPFLAGS    += -DMSTAMP=20080617

HOST := $(shell uname -i)
ifeq ("$(HOST)", "x86_64")
	MCMACHFLAGS += -m32
	CORELDFLAGS := -m elf_i386
	OCFLAGS := -O elf32-i386
endif

#CFLAGS	    += -DMARTIAN_CORE_DEBUG
#CFLAGS	    += -DDYNAMICRELOC_DEBUG
#CFLAGS	    += -DRELOCFIX_DEBUG		# to debug elf386tweakrelocs

# leave the relocations in
MLDFLAGS := $(MCMACHFLAGS) -lpthread -lrt
MCFLAGS += $(MCMACHFLAGS)

ifeq ("y","$(DEBUG)") 
	MLDFLAGS += -g
	CFLAGS += -g
endif

%.o: %.c
	@set -e; \
	echo -e "    CC\t$@"; \
	gcc -c $(CPPFLAGS) $(CFLAGS) $<

mmodem_source_objs := main.o \
	dumpers.o log.o \
	session.o mport.o \
	pty.o sysdep.o \
	isr.o smp.o \
	core_if.o coresubst.o \
	link.o tweakrelocsdynamic.o 

martian_modem_OBJS := $(mmodem_source_objs) marscore.o 
#$(mmodem_source_objs) coreadd.o: %.o: %.c
#	$(CC) $(CPPFLAGS) $(MCFLAGS) $(CFLAGS) -c $<

notify-obj: $(martian_modem_OBJS)
	@echo "Objects:"


$(mmodem_source_objs) coreadd.o: CFLAGS += $(MCMACHFLAGS)
				

core_if.o main.o session.o mport.o sysdep.o pty.o: sysdep.h 
main.o pty.o session.o mport.o: mport.h sysdep.h
main.o mport.o link.o dumpers.o isr.o coresubst.o: ../martian.h
session.o main.o smp.o: watch.h common.h
log.o main.o coresubst.o link.o mport.o pty.o: common.h
main.o pty.o mport.o link.o dumpers.o isr.o smp.o log.o session.o tweakrelocsdynamic.o sysdep.o: log.h common.h
core_if.o coresubst.o: overriden_core.h

main.o: CPPFLAGS += -DMSTAMP=20080617
	
overriden_core.h: overriden_core_functions
	@set -e; \
	> $@; \
	for sym in `<overriden_core_functions`; do \
		if grep -q -h " $$sym[[:blank:]]*(" core_if.c coresubst.c; then \
			grep -h " $$sym[[:blank:]]*(" core_if.c coresubst.c | sed -e "s/^/extern /" -e "s/$$sym/do_$$sym/" -e "s/).*/);/" >> $@; \
		fi \
	done

marscore.o: ltmdmobj.o coreadd.o elf386tweakrelocs overriden_core_functions
	@set -e; \
	echo -e "    LD\t$@"; \
	overriden_funcs=`<overriden_core_functions`; \
	ld -r \
		`for sym in $$overriden_funcs; do echo -n "--defsym do_$$sym=$$sym "; done` \
		$(CORELDFLAGS) -o marscore.o ltmdmobj.o coreadd.o
	@echo -e "    TWEAK\t$@"; \
	objcopy --weaken-symbols=overriden_core_functions \
		$(OCFLAGS) marscore.o; \
	./tweakcore.sh marscore.o 

#martian_modem: binaries := 1
#@if [ "$(binaries)" != "1" ] ; then echo "Binaries:"; fi 
martian_modem: MLDFLAGS := -Wl,-q $(MLDFLAGS)
martian_modem:	$(martian_modem_OBJS)
	@set -e; \
	echo -e "    LD\t$@"; \
	gcc -o $@ $(martian_modem_OBJS) $(MLDFLAGS) 

debug_script: debug_script.in martian_modem 
	@addr=`nm martian_modem | grep mcb_dump | awk '{print $$1}'`; \
	if [ "$${addr}" != "" ]; then sed "s/\&mcb_dump/0x$${addr}/" $< > $@; fi

ifeq ("y","$(DEBUG)")
all: debug_script
endif

elf386tweakrelocs: elf386tweakrelocs.c
	@set -e; \
	echo -e "    CC\t$@"; \
	gcc -o $@ $(CFLAGS) $(CPPFLAGS) $<

.PHONY: clean all install uninstall install-program install-debug debug-dir
clean:
	@echo -e "    RM\tOBJS"; rm -f $(martian_modem_OBJS) coreadd.o
	@echo -e "    RM\tBINS"; rm -f martian_modem{,.stripped,.debug}  
	@echo -e "    RM\tTOOLS"; rm -f relocs.sym elf386tweakrelocs
	@rm -f overriden_core.h relocs.sym
	@rm -f debug_script

relocs.sym: link.c
	@awk '/SYMBOL \(/ { sub (/^.*SYMBOL \(/,""); sub (/[,)].*/,""); print }\
	    /SYMBOL_TO_MEMBER \(/ { sub (/^.*SYMBOL_TO_MEMBER \(/,""); sub (/[,)].*/,""); print }' \
	    $< > $@

martian_modem.debug: $(martian_modem_OBJS) 
	@set -e; echo -e "    LD\t$@"; gcc -g -o $@ $(martian_modem_OBJS) $(MLDFLAGS) 
	@set -e; echo -e "    STRIP\t$@"; strip --only-keep-debug -o $@ $@ || rm $@
	
martian_modem.stripped: martian_modem martian_modem.debug relocs.sym
	@echo -e "    STRIP\t$@"; \
	objcopy --keep-symbols relocs.sym --add-gnu-debuglink=$<.debug --strip-all $< $@

all: martian_modem

install-program: target := /usr/sbin/martian_modem
install-program: martian_modem.stripped martian_modem.debug
	@echo -e "    INSTALL\t$(target)"
	@install $< $(target)

debug-dir:
	@[ -d /usr/lib/debug/usr/sbin ] || mkdir -p /usr/lib/debug/usr/sbin

install-debug: target := /usr/lib/debug/usr/sbin/martian_modem.debug
install-debug: martian_modem.debug debug-dir
	@echo -e "    INSTALL\t$(target)"
	@install $< $(target)


install: install-program install-debug
#//usr//sbin//martian_modem: martian_modem.stripped martian_modem.debug
/usr/sbin/martian_modem: martian_modem.stripped martian_modem.debug
	@echo -e "    INSTALL\t$@"
	@install $< $@

#install: /usb/sbin/martian_modem

uninstall: 
	rm /usr/sbin/martian_modem

test:
	echo $(DEBUG) $(CFLAGS)

## martian-modem 20080625

=== Makefile ===

KERNEL_DIR:=/lib/modules/$(shell uname -r)/build
SUBLEVEL:=$(shell echo $(KERNEL_DIR) | cut -d. -f3 | cut -d. -f1 | cut -d-  -f1)
# support begins at SUBLEVEL 20
after20:=$(shell if [ "$(SUBLEVEL)" -gt 20 ] ;then echo OK; fi)

ifdef after20
all: 
	$(MAKE) -C kmodule/ modules
	$(MAKE) -C modem/ all
#	$(MAKE) -C utils/ ptytosock

install:
	$(MAKE) -C kmodule/ install
	$(MAKE) -C modem/ install

else
20less:
	@echo "The martian_dev.ko driver and the complementary helper martian_helper are for use with kernels after 2.6.20. Use the martian-20080407.tar.gz for earlier kernels."
 
endif

clean:
	$(MAKE) -C kmodule/ clean
	$(MAKE) -C modem/ clean

=== kmodule/Makefile ===
--- 
+++ 
@@ -1,8 +1,12 @@
 KRELEASE = $(shell uname -r)
+ifdef  KERNEL_DIR
+KBUILD_DIR = $(KERNEL_DIR)
+else
 KBUILD_DIR = /lib/modules/$(KRELEASE)/build
+endif
 MSRC_DIR = $(shell pwd)
 
-martian_cppflags = -DKMARTIAN_STAMP=20080617
+martian_cppflags = -DKMARTIAN_STAMP=20080620
 EXTRA_CFLAGS	+= $(martian_cppflags)
 ccflags-y	+= $(martian_cppflags)

=== modem/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 CC	    := gcc
 
 CFLAGS	    := -Wall
-#CPPFLAGS    += -DMSTAMP=20080617
+#CPPFLAGS    += -DMSTAMP=20080620
 
 HOST := $(shell uname -i)
 ifeq ("$(HOST)", "x86_64")
@@ -59,7 +59,7 @@
 main.o pty.o mport.o link.o dumpers.o isr.o smp.o log.o session.o tweakrelocsdynamic.o sysdep.o: log.h common.h
 core_if.o coresubst.o: overriden_core.h
 
-main.o: CPPFLAGS += -DMSTAMP=20080617
+main.o: CPPFLAGS += -DMSTAMP=20080620
 	
 overriden_core.h: overriden_core_functions
 	@set -e; \

=== debian/changelog ===
martian-modem (20080625-2) unstable; urgency=low

  * The 'Thats-was-niceeeeee' dupload.
  * Use a hidden daemon's feature to allow custom mode, enabling regular 
     non-root users to dial-out through dialout group (Closes: #613773).
  * Depends on debhelper, fixes a build-dep issue on building the custom kernel
     module (Closes: #613896).
  * Switch package format to 3.0 (quilt).
  * Cleaning redundant build-deps (since we use quilt source format).
  * Update Standard-version to 3.9.1 (no changes needed).

 -- Ulises Vitulli <dererk@debian.org>  Sat, 26 Mar 2011 04:10:25 -0300

martian-modem (20080625-1) unstable; urgency=low

  * New upstream release (Closes: #521749). 
  * Patch for 2.6.32 linux scheduler (Closes: #563508).
    - debian/patches/include_2.6.32-scheduler.patch
    - debian/README.source: Created.
    - debian/control: Adding dependency on quilt.
  * Minor pkg fixes: 
    - debian/martian_modem.8: Fixing spelling errors (Closes: #563529).
    - Updated Package to apply to policy 3.8.3.
    - debian/control: Added misc:Depends.
    - debian/compat: Pop'd to 6 as we ask for newer debhelper.
    - debian/copyright: fixed non-utf8 symbol.
  * update-devfsd is no longer necessary (Closes: #561689).
  * debian/martian-modem.init.d: Consider the possibility that var/run dir
     could be a tmpfs-like.  

 -- Ulises Vitulli <uvitulli@fi.uba.ar>  Wed, 13 Jan 2010 13:29:58 -0300

martian-modem (20080617-1) unstable; urgency=low

  * New maintainer (Closes: #481430).
  * New upstream release (Closes: #484494, #486003).

 -- Ulises Vitulli <uvitulli@fi.uba.ar>  Tue, 17 Jun 2008 17:27:32 -0300

martian-modem (20071011-1) unstable; urgency=low

  * New upstream release (Closes: #448340, #473113, #473115)

 -- Mariano (Dererk) Velez <dererk@madap.com.ar>  Mon, 31 Mar 2008 01:29:01 -0300

martian-modem (20061203-1) unstable; urgency=low

  * Initial release (Closes: #435745)

 -- Mariano (Dererk) Velez <dererk@madap.com.ar>  Tue, 31 Jul 2007 23:50:30 -0300

=== debian/control ===
Source: martian-modem
Section: non-free/net
Priority: optional
Maintainer: Ulises Vitulli <dererk@debian.org>
Build-Depends: debhelper (>= 6.0.7~), bzip2
Standards-Version: 3.9.1
Homepage: http://phep2.technion.ac.il/linmodems/packages/ltmodem/kernel-2.6/martian

Package: martian-modem
Architecture: i386 
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ltmodem alternative driver providing support for Agere WinModem
 Martian is software to serve the Agere Systems PCI WinModem under Linux. 
 These are modems built on DSP 164x (Mars) series and major IBM ThinkPad A20 
 and many T20 series
 . 
 Project is established in the course of Linmodems group helping efforts

Package: martian-modem-source
Architecture: i386
Depends: ${misc:Depends}, debhelper, make, bzip2
Recommends: martian-modem, module-assistant
Description: Source for the martian-modem driver
 This package provides the source code for the martian-modem kernel module
 .
 Martian is software to serve the Agere Systems PCI WinModem under Linux. 
 These are modems built on DSP 164x (Mars) series and major IBM ThinkPad A20 
 and many T20 series

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif


# The short upstream name, used for the module source directory
sname:=martian-modem

# some default definitions, important!
# 
# Name of the source package
psource:=$(sname)-source

PKGMODULE:=martian-modem-source
PKG:=martian-modem

### KERNEL SETUP
### Setup the stuff needed for making kernel module packages
### taken from /usr/share/kernel-package/sample.module.rules

# modifieable for experiments or debugging m-a
MA_DIR ?= /usr/share/modass

# load generic variable handling
-include $(MA_DIR)/include/generic.make

# load default rules, including kdist, kdist_image, ...
-include $(MA_DIR)/include/common-rules.make
  
# module assistant calculates all needed things for us and sets
# following variables:
# KSRC (kernel source directory), KVERS (kernel version string), KDREV
# (revision of the Debian kernel-image package), CC (the correct
# compiler), VERSION (the final package version string), PKGNAME (full
# package name with KVERS included), DEB_DESTDIR (path to store DEBs)
  
# The kdist_config target is called by make-kpkg modules_config and
# by kdist* rules by dependency. It should configure the module so it is
# ready for compilation (mostly useful for calling configure).
# prep-deb-files from module-assistant creates the neccessary debian/ files 
kdist_config: prep-deb-files
  
# the kdist_clean target is called by make-kpkg modules_clean and from
# kdist* rules. It is responsible for cleaning up any changes that have
# been made by the other kdist_commands (except for the .deb files created)
kdist_clean:
#	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp
	
	# Cleaning kernel module building dir
	$(MAKE) -C source clean

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build-arch: configure-stamp  build-arch-stamp
build-arch-stamp:
	dh_testdir
	touch $@

k = $(shell echo $(KVERS) | grep -q ^2.6 && echo k)
# the binary-modules rule is invoked by module-assistant while processing the
# kdist* targets. It is called by module-assistant or make-kpkg and *not*
# during a normal build
binary-modules:
	dh_testroot
	dh_clean -k
	dh_installdirs lib/modules/$(KVERS)/extra
	# Build the module
	$(MAKE) -C source KERNEL_DIR=$(KSRC) KVERS=$(KVERS)
	
	# Install the module
	dh_install source/martian_dev.$ko lib/modules/$(KVERS)/extra
	
	# Building package stuff
	dh_installdocs debian/copyright README Concept
	dh_installchangelogs ChangeLog
	dh_compress 
	dh_fixperms 
	dh_installdeb 
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums 
	dh_builddeb --destdir=$(CURDIR)

build-indep: configure-stamp build-indep-stamp 
build-indep-stamp:
	dh_testdir
	touch $@

build: build-arch build-indep
	
	# Userspace tool building
	#
	$(MAKE) -C modem


clean: 
	#dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp
			
	# Cleaning userspace util
	$(MAKE) -C modem clean
	
	dh_clean

#install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	
	# Creating kernel module source container
	#
	dh_installdirs -p$(PKGMODULE) -i usr/src/modules/$(sname)/debian  usr/src/modules/$(sname)/source
	dh_link -s -p$(PKGMODULE) ../packages/default.sh usr/share/modass/overrides/$(PKGMODULE)
	
	# Copy only the driver source to the proper location
	dh_install -p$(PKGMODULE) *.[ch] usr/src/modules/$(sname)/source
	
	# Copy the needed debian/ pieces to the proper location
	dh_install -p$(PKGMODULE) ChangeLog README Concept usr/src/modules/$(sname)
	dh_install -p$(PKGMODULE) debian/*modules.in* usr/src/modules/$(sname)/debian
	dh_install -p$(PKGMODULE) debian/*_KVERS_* debian/rules debian/changelog debian/copyright \
                debian/compat usr/src/modules/$(sname)/debian/
	
	# Changing original martian.h path from upstream
	dh_install -p$(PKGMODULE) kmodule/* usr/src/modules/$(sname)/source
	
	# Due the lack of privative software and terms under "Redistribution and Usage" specified in Copyright section 2.3.2
	#    no modifications can be made over any files for distribution (read Copyright)
	dh_install -p$(PKGMODULE) martian.h usr/src/modules/$(sname)	
	
	# Have to set permissions now before tar'ing
	chown -R root.src debian/$(psource)/usr/src/modules
	cd debian/$(PKGMODULE)/usr/src && tar c modules | bzip2 -9 > $(sname).tar.bz2 && rm -rf modules; cd -
	
	# Creating userspace utils stuff
	#
	dh_installdirs -p$(PKG) /usr/sbin
	
	$(MAKE) -C modem all
	 
	dh_install -p$(PKG) modem/martian_modem usr/sbin



# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build install
	dh_testdir 
	dh_testroot 
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples scripts/wv.conf
	dh_installinit -p$(PKG)
	dh_installman -p$(PKG) debian/martian_modem.8
	dh_install 
	dh_lintian -p$(PKG)
	dh_link 
	dh_compress 
	dh_fixperms 
	dh_makeshlibs
	dh_installdeb 
	dh_shlibdeps 
	dh_gencontrol 
	dh_md5sums 
	dh_builddeb 

binary: binary-indep
.PHONY: build clean binary-indep binary install configure binary-modules kdist kdist_configure kdist_image kdist_clean
